type CreatePipelineCommentPayload {
  clientMutationId: String
  comment: Comment
  problems: [Problem!]!
}

type UpdatePipelineCommentPayload {
  clientMutationId: String
  comment: Comment
  problems: [Problem!]!
}

type DeletePipelineCommentPayload {
  clientMutationId: String
  problems: [Problem!]!
}

type CreateReleaseCommentPayload {
  clientMutationId: String
  comment: Comment
  problems: [Problem!]!
}

type UpdateReleaseCommentPayload {
  clientMutationId: String
  comment: Comment
  problems: [Problem!]!
}

type DeleteReleaseCommentPayload {
  clientMutationId: String
  problems: [Problem!]!
}

type Comment implements Node {
  id: ID!
  metadata: ResourceMetadata!
  creator: Caller
  thread: Thread!
  text: String!
}

input CreatePipelineCommentInput {
  clientMutationId: String
  pipelineId: String
  threadId: String
  text: String!
}

input UpdatePipelineCommentInput {
  clientMutationId: String
  id: String!
  text: String!
  metadata: ResourceMetadataInput
}

input DeletePipelineCommentInput {
  clientMutationId: String
  id: String!
  metadata: ResourceMetadataInput
}

input CreateReleaseCommentInput {
  clientMutationId: String
  releaseId: String
  threadId: String
  text: String!
}

input UpdateReleaseCommentInput {
  clientMutationId: String
  id: String!
  text: String!
  metadata: ResourceMetadataInput
}

input DeleteReleaseCommentInput {
  clientMutationId: String
  id: String!
  metadata: ResourceMetadataInput
}

type CommentEvent {
  action: String!
  comment: Comment!
}

input CommentEventsSubscriptionInput {
  pipelineId: String
  releaseId: String
}
